/**
 * 
 */
package com.centfor;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ResourceBundle;

import org.apache.log4j.Logger;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.centfor.util.HttpUtils;

/**
* 监听服务
*
* @author baobao
* @date 2012-7-30
*/

public class CheckService {
	static Logger logger = Logger.getLogger(CheckService.class); 
	/**
	 * 
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args)  {
		ResourceBundle p = ResourceBundle.getBundle("config");
		String checklist = p.getString("checklist");
		String t = p.getString("total");
		Double i_total = Double.valueOf(t);
		Integer i_time = Integer.valueOf(p.getString("time"));
		JSONArray array = JSON.parseArray(checklist);
		for (int i = 0; i < array.size(); i++) {
			JSONObject json = array.getJSONObject(i);
			String url = json.getString("url");
			JSONObject context = HttpUtils.getContext(url);
			Double total = context.getDouble("total");
			Integer time = context.getInteger("time");
			if (total > i_total || time > i_time) {
				
					restart(context, json);
				
			}

		}

	}

	/**
	 * 
	 * @param context
	 * @throws IOException 
	 */
	public static void restart(JSONObject context, JSONObject json)  {
		String url = json.getString("url");
		String port = url.replace("://", "");
		port = port.substring(port.indexOf(":") + 1, port.indexOf("/"));
		String os = context.getString("os").toLowerCase();
		String serviceName = json.getString("servicename");
		String message="";
		if (os.contains("windows")) {
			message=windows(port, serviceName);
		} else if (os.contains("linux")) {
			message=linux(port, serviceName);
		}
		logger.info(message);

	}

	public static String windows(String port, String serviceName)  {
		String message = "重启"+serviceName+"失败!";
		Process p;
		BufferedReader br=null;
		try {
			p = Runtime.getRuntime().exec("cmd.exe /c netstat -ano|findstr \"" + port + "\" ");
		
		 br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		String msg = null;
		while ((msg = br.readLine()) != null) {
			msg = msg.toLowerCase();
			if (msg.contains("listening")) {
				String pid = msg.substring(msg.indexOf("listening") + 9).trim();
				Runtime.getRuntime().exec("cmd.exe /c taskkill /F /PID " + pid);
				Thread.sleep(1000);
				Runtime.getRuntime().exec("cmd.exe /c net start " + serviceName);
			}
		}
		br.close();
		message="重启"+serviceName+"成功";
		} catch (Exception e) {
			try {
				if(br!=null)
				br.close();
			} catch (IOException e1) {
				logger.error(e1);
			}
			logger.error(e);
		}
		
		return message;
	}

	public static String linux(String port, String serviceName) {
		String message = "重启失败!";
		Process p;
		BufferedReader br=null;
		try {
			p = Runtime.getRuntime().exec(new String[]{"/bin/sh","-c","netstat -nalpt|grep "+port});
		
		 br = new BufferedReader(new InputStreamReader(p.getInputStream()));
		String msg = null;
		while ((msg = br.readLine()) != null) {
			msg = msg.toLowerCase();
			if (msg.contains("listen")) {
				String pid = msg.substring(msg.indexOf("listen") + 6,msg.indexOf("/")).trim();
				Runtime.getRuntime().exec(new String[]{"/bin/sh","-c"," kill -9 "+pid});
				Thread.sleep(1000);
				Runtime.getRuntime().exec(new String[]{"/bin/sh","-c"," service  "+serviceName+" start"});
			}
		}
		br.close();
		message="重启成功";
		} catch (Exception e) {
			try {
				if(br!=null)
				br.close();
			} catch (IOException e1) {
				logger.error(e1);
			}
			logger.error(e);
		}
		return message;
	}
}
